var root = this,
Readability = function (e, t, i) {
    var n;
    i = i || {}, this._uri = e, this._doc = t, this._biggestFrame = !1, this._articleByline = null, this._articleDir = null, this._debug = !!i.debug, this._maxElemsToParse = i.maxElemsToParse || this.DEFAULT_MAX_ELEMS_TO_PARSE, this._nbTopCandidates = i.nbTopCandidates || this.DEFAULT_N_TOP_CANDIDATES, this._maxPages = i.maxPages || this.DEFAULT_MAX_PAGES, this._flags = this.FLAG_STRIP_UNLIKELYS | this.FLAG_WEIGHT_CLASSES | this.FLAG_CLEAN_CONDITIONALLY, this._parsedPages = {}, this._pageETags = {}, this._curPageNum = 1, this._debug ? (n = function (e) {
        var t = e.nodeName + " ";
        if (e.nodeType == e.TEXT_NODE) return t + '("' + e.textContent + '")';
        var i = e.className && "." + e.className.replace(/ /g, "."), n = "";
        return e.id ? n = "(#" + e.id + i + ")" : i && (n = "(" + i + ")"), t + n
    }, this.log = function () {
        var e;
        "dump" in root ? (e = Array.prototype.map.call(arguments, function (e) {
            return e && e.nodeName ? n(e) : e
        }).join(" "), dump("Reader: (Readability) " + e + "\n")) : "console" in root && (e = ["Reader: (Readability) "].concat(arguments), console.log.apply(console, e))
    }) : this.log = function () {
    }
};
Readability.prototype = {
    FLAG_STRIP_UNLIKELYS: 1,
    FLAG_WEIGHT_CLASSES: 2,
    FLAG_CLEAN_CONDITIONALLY: 4,
    DEFAULT_MAX_ELEMS_TO_PARSE: 0,
    DEFAULT_N_TOP_CANDIDATES: 5,
    DEFAULT_MAX_PAGES: 5,
    DEFAULT_TAGS_TO_SCORE: "section,h2,h3,h4,h5,h6,p,td,pre".toUpperCase().split(","),
    REGEXPS: {
        unlikelyCandidates: /banner|combx|comment|community|disqus|extra|foot|header|menu|modal|related|remark|rss|share|shoutbox|sidebar|skyscraper|sponsor|ad-break|agegate|pagination|pager|popup/i,
        okMaybeItsACandidate: /and|article|body|column|main|shadow/i,
        positive: /article|body|content|entry|hentry|main|page|pagination|post|text|blog|story/i,
        negative: /hidden|^hid$| hid$| hid |^hid |banner|combx|comment|com-|contact|foot|footer|footnote|masthead|media|meta|modal|outbrain|promo|related|scroll|share|shoutbox|sidebar|skyscraper|sponsor|shopping|tags|tool|widget/i,
        extraneous: /print|archive|comment|discuss|e[\-]?mail|share|reply|all|login|sign|single|utility/i,
        byline: /byline|author|dateline|writtenby/i,
        replaceFonts: /<(\/?)font[^>]*>/gi,
        normalize: /\s{2,}/g,
        videos: /\/\/(www\.)?(dailymotion|youtube|youtube-nocookie|player\.vimeo)\.com/i,
        nextLink: /(next|weiter|continue|>([^\|]|$)|»([^\|]|$))/i,
        prevLink: /(prev|earl|old|new|<|«)/i,
        whitespace: /^\s*$/,
        hasContent: /\S$/
    },
    DIV_TO_P_ELEMS: ["A", "BLOCKQUOTE", "DL", "DIV", "IMG", "OL", "P", "PRE", "TABLE", "UL", "SELECT"],
    ALTER_TO_DIV_EXCEPTIONS: ["DIV", "ARTICLE", "SECTION", "P"],
    _postProcessContent: function (e) {
        this._fixRelativeUris(e)
    },
    _forEachNode: function (e, t) {
        return Array.prototype.forEach.call(e, t, this)
    },
    _someNode: function (e, t) {
        return Array.prototype.some.call(e, t, this)
    },
    _concatNodeLists: function () {
        var t = Array.prototype.slice, e = t.call(arguments).map(function (e) {
            return t.call(e)
        });
        return Array.prototype.concat.apply([], e)
    },
    _getAllNodesWithTag: function (t, e) {
        return t.querySelectorAll ? t.querySelectorAll(e.join(",")) : [].concat.apply([], e.map(function (e) {
            e = t.getElementsByTagName(e);
            return Array.isArray(e) ? e : Array.from(e)
        }))
    },
    _fixRelativeUris: function (e) {
        var t = this._uri.scheme, i = this._uri.prePath, n = this._uri.pathBase;

        function s(e) {
            return /^[a-zA-Z][a-zA-Z0-9\+\-\.]*:/.test(e) ? e : "//" == e.substr(0, 2) ? t + "://" + e.substr(2) : "/" == e[0] ? i + e : 0 === e.indexOf("./") ? n + e.slice(2) : "#" == e[0] ? e : n + e
        }

        e.innerHTML = e.innerHTML.replace(/(<[^>]+(src|href)\s*=\s*['"]?)(?:(?!(https|ftp|http)))([^'"\s]+)([^>]*?>)/gi, function (e, t, i, n, a, r) {
            return t + s(a) + r
        })
    },
    _getArticleTitle: function () {
        var e, t = this._doc, i = "", n = "";
        try {
            "string" != typeof (i = n = t.title) && (i = n = this._getInnerText(t.getElementsByTagName("title")[0]))
        } catch (e) {
        }
        return i.match(/ [\|\-] /) ? (i = n.replace(/(.*)[\|\-] .*/gi, "$1")).split(" ").length < 3 && (i = n.replace(/[^\|\-]*[\|\-](.*)/gi, "$1")) : -1 !== i.indexOf(": ") ? (e = this._concatNodeLists(t.getElementsByTagName("h1"), t.getElementsByTagName("h2")), this._someNode(e, function (e) {
            return e.textContent === i
        }) || (i = n.substring(n.lastIndexOf(":") + 1)).split(" ").length < 3 && (i = n.substring(n.indexOf(":") + 1))) : (150 < i.length || i.length < 15) && 1 === (e = t.getElementsByTagName("h1")).length && (i = this._getInnerText(e[0])), i = (i = i.trim()).split(" ").length <= 4 ? n : i
    },
    _prepDocument: function () {
        var e = this._doc;
        this._forEachNode(e.getElementsByTagName("style"), function (e) {
            e.parentNode.removeChild(e)
        }), e.body && this._replaceBrs(e.body), this._forEachNode(e.getElementsByTagName("font"), function (e) {
            this._setNodeTag(e, "SPAN")
        })
    },
    _nextElement: function (e) {
        for (var t = e; t && t.nodeType != Node.ELEMENT_NODE && this.REGEXPS.whitespace.test(t.textContent);) t = t.nextSibling;
        return t
    },
    _replaceBrs: function (e) {
        this._forEachNode(e.getElementsByTagName("br"), function (e) {
            for (var t = e.nextSibling, i = !1; (t = this._nextElement(t)) && "BR" == t.tagName;) {
                var i = !0, n = t.nextSibling;
                t.parentNode.removeChild(t), t = n
            }
            if (i) {
                var a = this._doc.createElement("p");
                for (e.parentNode.replaceChild(a, e), t = a.nextSibling; t;) {
                    if ("BR" == t.tagName) {
                        var r = this._nextElement(t);
                        if (r && "BR" == r.tagName) break
                    }
                    r = t.nextSibling;
                    a.appendChild(t), t = r
                }
            }
        })
    },
    _setNodeTag: function (e, t) {
        if (this.log("_setNodeTag", e, t), e.__JSDOMParser__) return e.localName = t.toLowerCase(), e.tagName = t.toUpperCase(), e;
        for (var i = e.ownerDocument.createElement(t); e.firstChild;) i.appendChild(e.firstChild);
        e.parentNode.replaceChild(i, e), e.readability && (i.readability = e.readability);
        for (var n = 0; n < e.attributes.length; n++) i.setAttribute(e.attributes[n].name, e.attributes[n].value);
        return i
    },
    _prepArticle: function (e) {
        this._cleanStyles(e), this._cleanConditionally(e, "form"), this._clean(e, "object"), this._clean(e, "embed"), this._clean(e, "h1"), this._clean(e, "footer"), 1 === e.getElementsByTagName("h2").length && this._clean(e, "h2"), this._clean(e, "iframe"), this._cleanHeaders(e), this._cleanConditionally(e, "table"), this._cleanConditionally(e, "ul"), this._cleanConditionally(e, "div"), this._forEachNode(e.getElementsByTagName("p"), function (e) {
            0 !== e.getElementsByTagName("img").length + e.getElementsByTagName("embed").length + e.getElementsByTagName("object").length + e.getElementsByTagName("iframe").length || this._getInnerText(e, !1) || e.parentNode.removeChild(e)
        }), this._forEachNode(e.getElementsByTagName("br"), function (e) {
            var t = this._nextElement(e.nextSibling);
            t && "P" == t.tagName && e.parentNode.removeChild(e)
        })
    },
    _initializeNode: function (e) {
        switch (e.readability = {contentScore: 0}, e.tagName) {
            case"DIV":
                e.readability.contentScore += 5;
                break;
            case"PRE":
            case"TD":
            case"BLOCKQUOTE":
                e.readability.contentScore += 3;
                break;
            case"ADDRESS":
            case"OL":
            case"UL":
            case"DL":
            case"DD":
            case"DT":
            case"LI":
            case"FORM":
                e.readability.contentScore -= 3;
                break;
            case"H1":
            case"H2":
            case"H3":
            case"H4":
            case"H5":
            case"H6":
            case"TH":
                e.readability.contentScore -= 5
        }
        e.readability.contentScore += this._getClassWeight(e)
    },
    _removeAndGetNext: function (e) {
        var t = this._getNextNode(e, !0);
        return e.parentNode.removeChild(e), t
    },
    _getNextNode: function (e, t) {
        if (!t && e.firstElementChild) return e.firstElementChild;
        if (e.nextElementSibling) return e.nextElementSibling;
        for (; (e = e.parentNode) && !e.nextElementSibling;) ;
        return e && e.nextElementSibling
    },
    _getNextNodeNoElementProperties: function (e, t) {
        function i(e) {
            for (; (e = e.nextSibling) && e.nodeType !== e.ELEMENT_NODE;) ;
            return e
        }

        if (!t && e.children[0]) return e.children[0];
        var n = i(e);
        if (n) return n;
        for (; (e = e.parentNode) && (n = i(e)), e && !n;) ;
        return e && n
    },
    _checkByline: function (e, t) {
        return !this._articleByline && (!("author" !== (i = void 0 !== e.getAttribute ? e.getAttribute("rel") : i) && !this.REGEXPS.byline.test(t) || !this._isValidByline(e.textContent)) && (this._articleByline = e.textContent.trim(), !0));
        var i
    },
    _getNodeAncestors: function (e, t) {
        t = t || 0;
        for (var i = 0, n = []; e.parentNode && (n.push(e.parentNode), !t || ++i !== t);) e = e.parentNode;
        return n
    },
    _grabArticle: function (e) {
        this.log("**** grabArticle ****");
        var i = this._doc, t = null !== e;
        if (!(e = e || this._doc.body)) return this.log("No body found in document. Abort."), null;
        var n = e.innerHTML;
        for (this._articleDir = i.documentElement.getAttribute("dir"); ;) {
            for (var a = this._flagIsActive(this.FLAG_STRIP_UNLIKELYS), r = [], s = this._doc.documentElement; s;) {
                var o = s.className + " " + s.id;
                this._checkByline(s, o) ? s = this._removeAndGetNext(s) : s = a && this.REGEXPS.unlikelyCandidates.test(o) && !this.REGEXPS.okMaybeItsACandidate.test(o) && "BODY" !== s.tagName && "A" !== s.tagName ? (this.log("Removing unlikely candidate - " + o), this._removeAndGetNext(s)) : (-1 !== this.DEFAULT_TAGS_TO_SCORE.indexOf(s.tagName) && r.push(s), "DIV" === s.tagName && (this._hasSinglePInsideElement(s) ? (o = s.children[0], s.parentNode.replaceChild(o, s), s = o) : this._hasChildBlockElement(s) ? this._forEachNode(s.childNodes, function (e) {
                    var t;
                    e.nodeType === Node.TEXT_NODE && ((t = i.createElement("p")).textContent = e.textContent, t.style.display = "inline", t.className = "readability-styled", s.replaceChild(t, e))
                }) : (s = this._setNodeTag(s, "P"), r.push(s))), this._getNextNode(s))
            }
            for (var l = [], c = (this._forEachNode(r, function (e) {
                var t, i;
                !e.parentNode || void 0 === e.parentNode.tagName || (t = this._getInnerText(e)).length < 25 || 0 !== (e = this._getNodeAncestors(e, 3)).length && (i = 0, ++i, i = (i += t.split(",").length) + Math.min(Math.floor(t.length / 100), 3), this._forEachNode(e, function (e, t) {
                    e.tagName && (void 0 === e.readability && (this._initializeNode(e), l.push(e)), e.readability.contentScore += i / (0 === t ? 1 : 1 === t ? 2 : 3 * t))
                }))
            }), []), h = 0, d = l.length; h < d; h += 1) {
                var g = l[h], p = g.readability.contentScore * (1 - this._getLinkDensity(g));
                g.readability.contentScore = p, this.log("Candidate:", g, "with score " + p);
                for (var _ = 0; _ < this._nbTopCandidates; _++) {
                    var m = c[_];
                    if (!m || p > m.readability.contentScore) {
                        c.splice(_, 0, g), c.length > this._nbTopCandidates && c.pop();
                        break
                    }
                }
            }
            var u = !1;
            if (null === (f = c[0] || null) || "BODY" === f.tagName) {
                for (var f = i.createElement("DIV"), u = !0, E = e.childNodes; E.length;) this.log("Moving child out:", E[0]), f.appendChild(E[0]);
                e.appendChild(f), this._initializeNode(f)
            } else if (f) for (var N = f.parentNode, y = f.readability.contentScore, T = y / 3; N && N.readability;) {
                var b = N.readability.contentScore;
                if (b < T) break;
                if (y < b) {
                    f = N;
                    break
                }
                y = N.readability.contentScore, N = N.parentNode
            }
            for (var v = i.createElement("DIV"), A = (t && (v.id = "readability-content"), Math.max(10, .2 * f.readability.contentScore)), S = f.parentNode.children, L = 0, x = S.length; L < x; L++) {
                var C, P, I, B = S[L], R = !1;
                this.log("Looking at sibling node:", B, B.readability ? "with score " + B.readability.contentScore : ""), this.log("Sibling has score", B.readability ? B.readability.contentScore : "Unknown"), B === f ? R = !0 : (C = 0, B.className === f.className && "" !== f.className && (C += .2 * f.readability.contentScore), B.readability && B.readability.contentScore + C >= A ? R = !0 : "P" === B.nodeName && (C = this._getLinkDensity(B), (80 < (I = (P = this._getInnerText(B)).length) && C < .25 || I < 80 && 0 < I && 0 === C && -1 !== P.search(/\.( |$)/)) && (R = !0))), R && (this.log("Appending node:", B), -1 === this.ALTER_TO_DIV_EXCEPTIONS.indexOf(B.nodeName) && (this.log("Altering sibling:", B, "to div."), B = this._setNodeTag(B, "DIV")), v.appendChild(B), --L, --x)
            }
            if (this._debug && this.log("Article content pre-prep: " + v.innerHTML), this._prepArticle(v), this._debug && this.log("Article content post-prep: " + v.innerHTML), 1 === this._curPageNum) if (u) f.id = "readability-page-1", f.className = "page"; else {
                for (var D = i.createElement("DIV"), G = (D.id = "readability-page-1", D.className = "page", v.childNodes); G.length;) D.appendChild(G[0]);
                v.appendChild(D)
            }
            if (this._debug && this.log("Article content after paging: " + v.innerHTML), !(this._getInnerText(v, !0).length < 500)) return v;
            if (e.innerHTML = n, this._flagIsActive(this.FLAG_STRIP_UNLIKELYS)) this._removeFlag(this.FLAG_STRIP_UNLIKELYS); else if (this._flagIsActive(this.FLAG_WEIGHT_CLASSES)) this._removeFlag(this.FLAG_WEIGHT_CLASSES); else {
                if (!this._flagIsActive(this.FLAG_CLEAN_CONDITIONALLY)) return null;
                this._removeFlag(this.FLAG_CLEAN_CONDITIONALLY)
            }
        }
    },
    _isValidByline: function (e) {
        return ("string" == typeof e || e instanceof String) && (0 < (e = e.trim()).length && e.length < 100)
    },
    _getArticleMetadata: function () {
        var a = {}, r = {}, e = this._doc.getElementsByTagName("meta"),
            s = /^\s*((twitter)\s*:\s*)?(description|title)\s*$/gi, o = /^\s*og\s*:\s*(description|title)\s*$/gi;
        return this._forEachNode(e, function (e) {
            var t, i = e.getAttribute("name"), n = e.getAttribute("property");
            -1 !== [i, n].indexOf("author") ? a.byline = e.getAttribute("content") : (t = null, s.test(i) ? t = i : o.test(n) && (t = n), t && (i = e.getAttribute("content")) && (t = t.toLowerCase().replace(/\s/g, ""), r[t] = i.trim()))
        }), "description" in r ? a.excerpt = r.description : "og:description" in r ? a.excerpt = r["og:description"] : "twitter:description" in r && (a.excerpt = r["twitter:description"]), "og:title" in r ? a.title = r["og:title"] : "twitter:title" in r && (a.title = r["twitter:title"]), a
    },
    _removeScripts: function (e) {
        this._forEachNode(e.getElementsByTagName("script"), function (e) {
            e.nodeValue = "", e.removeAttribute("src"), e.parentNode && e.parentNode.removeChild(e)
        }), this._forEachNode(e.getElementsByTagName("noscript"), function (e) {
            e.parentNode && e.parentNode.removeChild(e)
        })
    },
    _hasSinglePInsideElement: function (e) {
        return 1 == e.children.length && "P" === e.children[0].tagName && !this._someNode(e.childNodes, function (e) {
            return e.nodeType === Node.TEXT_NODE && this.REGEXPS.hasContent.test(e.textContent)
        })
    },
    _hasChildBlockElement: function (e) {
        return this._someNode(e.childNodes, function (e) {
            return -1 !== this.DIV_TO_P_ELEMS.indexOf(e.tagName) || this._hasChildBlockElement(e)
        })
    },
    _getInnerText: function (e, t) {
        t = void 0 === t || t;
        e = e.textContent.trim();
        return t ? e.replace(this.REGEXPS.normalize, " ") : e
    },
    _getCharCount: function (e, t) {
        return t = t || ",", this._getInnerText(e).split(t).length - 1
    },
    _cleanStyles: function (e) {
        if (e = e || this._doc) {
            var t = e.firstChild;
            for ("function" == typeof e.removeAttribute && "readability-styled" !== e.className && e.removeAttribute("style"); null !== t;) t.nodeType === t.ELEMENT_NODE && ("readability-styled" !== t.className && t.removeAttribute("style"), this._cleanStyles(t)), t = t.nextSibling
        }
    },
    _getLinkDensity: function (e) {
        var t = this._getInnerText(e).length;
        if (0 === t) return 0;
        var i = 0;
        return this._forEachNode(e.getElementsByTagName("a"), function (e) {
            i += this._getInnerText(e).length
        }), i / t
    },
    _findBaseUrl: function () {
        for (var e = this._uri, t = e.path.split("?")[0].split("/").reverse(), i = [], n = 0, a = t.length; n < a; n += 1) {
            var r = t[n],
                s = (!(r = -1 !== (r = -1 === r.indexOf(".") || r.split(".")[1].match(/[^a-zA-Z]/) ? r : r.split(".")[0]).indexOf(",00") ? r.replace(",00", "") : r).match(/((_|-)?p[a-z]*|(_|-))[0-9]{1,2}$/i) || 1 !== n && 0 !== n || (r = r.replace(/((_|-)?p[a-z]*|(_|-))[0-9]{1,2}$/i, "")), !1);
            n < 2 && r.match(/^\d{1,2}$/) && (s = !0), 0 === n && "index" === r.toLowerCase() && (s = !0), (s = n < 2 && r.length < 3 && !t[0].match(/[a-z]/i) ? !0 : s) || i.push(r)
        }
        return e.scheme + "://" + e.host + i.reverse().join("/")
    },
    _findNextPageLink: function (e) {
        for (var t = this._uri, i = {}, n = e.getElementsByTagName("a"), a = this._findBaseUrl(), r = 0, s = n.length; r < s; r += 1) {
            var o = n[r], l = n[r].href.replace(/#.*$/, "").replace(/\/$/, "");
            if (!("" === l || l === a || l === t.spec || l in this._parsedPages) && t.host === l.split(/\/+/g)[1]) {
                var c = this._getInnerText(o);
                if (!(c.match(this.REGEXPS.extraneous) || 25 < c.length)) if (l.replace(a, "").match(/\d/)) {
                    l in i ? i[l].linkText += " | " + c : i[l] = {score: 0, linkText: c, href: l};
                    for (var h = i[l], d = (0 !== l.indexOf(a) && (h.score -= 25), c + " " + o.className + " " + o.id), g = (d.match(this.REGEXPS.nextLink) && (h.score += 50), d.match(/pag(e|ing|inat)/i) && (h.score += 25), !d.match(/(first|last)/i) || h.linkText.match(this.REGEXPS.nextLink) || (h.score -= 65), (d.match(this.REGEXPS.negative) || d.match(this.REGEXPS.extraneous)) && (h.score -= 50), d.match(this.REGEXPS.prevLink) && (h.score -= 200), o.parentNode), p = !1, _ = !1; g;) {
                        var m = g.className + " " + g.id;
                        !p && m && m.match(/pag(e|ing|inat)/i) && (p = !0, h.score += 25), _ || !m || !m.match(this.REGEXPS.negative) || m.match(this.REGEXPS.positive) || (h.score -= 25, _ = !0), g = g.parentNode
                    }
                    (l.match(/p(a|g|ag)?(e|ing|ination)?(=|\/)[0-9]{1,2}/i) || l.match(/(page|paging)/i)) && (h.score += 25), l.match(this.REGEXPS.extraneous) && (h.score -= 15);
                    d = parseInt(c, 10);
                    d && (1 === d ? h.score -= 10 : h.score += Math.max(0, 10 - d))
                }
            }
        }
        var u, f = null;
        for (u in i) i.hasOwnProperty(u) && 50 <= i[u].score && (!f || f.score < i[u].score) && (f = i[u]);
        return f ? (e = f.href.replace(/\/$/, ""), this.log("NEXT PAGE IS " + e), this._parsedPages[e] = !0, e) : null
    },
    _successfulRequest: function (e) {
        return 200 <= e.status && e.status < 300 || 304 === e.status || 0 === e.status && e.responseText
    },
    _ajax: function (e, t) {
        var i = new XMLHttpRequest;
        void 0 === t && (t = {}), i.onreadystatechange = function (e) {
            4 === i.readyState && (this._successfulRequest(i) ? t.success && t.success(i) : t.error && t.error(i))
        }, i.open("get", e, !0), i.setRequestHeader("Accept", "text/html");
        try {
            i.send(t.postBody)
        } catch (e) {
            t.error && t.error()
        }
        return i
    },
    _appendNextPage: function (e) {
        var o = this._doc, l = (this._curPageNum += 1, o.createElement("DIV"));
        l.id = "readability-page-" + this._curPageNum, l.className = "page", l.innerHTML = '<p class="page-separator" title="Page ' + this._curPageNum + '">&sect;</p>', o.getElementById("readability-content").appendChild(l), this._curPageNum > this._maxPages ? l.innerHTML = l.innerHTML + ("<div style='text-align: center'><a href='" + e + "'>View Next Page</a></div>") : function (r, s) {
            this._ajax(r, {
                success: function (e) {
                    var t = e.getResponseHeader("ETag");
                    if (t) {
                        if (t in this._pageETags) return this.log("Exact duplicate page found via ETag. Aborting."), void (l.style.display = "none");
                        this._pageETags[t] = 1
                    }
                    t = o.createElement("DIV"), e = e.responseText.replace(/\n/g, "￿").replace(/<script.*?>.*?<\/script>/gi, ""), e = (e = (e = e.replace(/\n/g, "￿").replace(/<script.*?>.*?<\/script>/gi, "")).replace(/\uffff/g, "\n").replace(/<(\/?)noscript/gi, "<$1div")).replace(this.REGEXPS.replaceFonts, "<$1span>"), t.innerHTML = e, this._replaceBrs(t), this._flags = 7, e = this._findNextPageLink(t), t = this._grabArticle(t);
                    if (t) {
                        var i = t.getElementsByTagName("P").length ? t.getElementsByTagName("P")[0] : null;
                        if (i && 100 < i.innerHTML.length) for (var n = 1; n <= this._curPageNum; n += 1) {
                            var a = o.getElementById("readability-page-" + n);
                            if (a && -1 !== a.innerHTML.indexOf(i.innerHTML)) return this.log("Duplicate of page " + n + " - skipping."), l.style.display = "none", void (this._parsedPages[r] = !0)
                        }
                        this._removeScripts(t), s.innerHTML = s.innerHTML + t.innerHTML, setTimeout(function () {
                            this._postProcessContent(s)
                        }.bind(this), 500), e && this._appendNextPage(e)
                    } else this.log("No content found in page to append. Aborting.")
                }
            })
        }.bind(this)(e, l)
    },
    _getClassWeight: function (e) {
        if (!this._flagIsActive(this.FLAG_WEIGHT_CLASSES)) return 0;
        var t = 0;
        return "string" == typeof e.className && "" !== e.className && (this.REGEXPS.negative.test(e.className) && (t -= 25), this.REGEXPS.positive.test(e.className) && (t += 25)), "string" == typeof e.id && "" !== e.id && (this.REGEXPS.negative.test(e.id) && (t -= 25), this.REGEXPS.positive.test(e.id) && (t += 25)), t
    },
    _clean: function (e, t) {
        var i = -1 !== ["object", "embed", "iframe"].indexOf(t);
        this._forEachNode(e.getElementsByTagName(t), function (e) {
            if (i) {
                var t = [].map.call(e.attributes, function (e) {
                    return e.value
                }).join("|");
                if (this.REGEXPS.videos.test(t)) return;
                if (this.REGEXPS.videos.test(e.innerHTML)) return
            }
            e.parentNode.removeChild(e)
        })
    },
    _hasAncestorTag: function (e, t, i) {
        i = i || 3, t = t.toUpperCase();
        for (var n = 0; e.parentNode;) {
            if (i < n) return !1;
            if (e.parentNode.tagName === t) return !0;
            e = e.parentNode, n++
        }
        return !1
    },
    _cleanConditionally: function (e, t) {
        if (this._flagIsActive(this.FLAG_CLEAN_CONDITIONALLY)) for (var i = e.getElementsByTagName(t), n = "ul" === t || "ol" === t, a = i.length - 1; 0 <= a; --a) {
            var r = this._getClassWeight(i[a]);
            if (this.log("Cleaning Conditionally", i[a]), r + 0 < 0) i[a].parentNode.removeChild(i[a]); else if (this._getCharCount(i[a], ",") < 10) {
                for (var s = i[a].getElementsByTagName("p").length, o = i[a].getElementsByTagName("img").length, l = i[a].getElementsByTagName("li").length - 100, c = i[a].getElementsByTagName("input").length, h = 0, d = i[a].getElementsByTagName("embed"), g = 0, p = d.length; g < p; g += 1) this.REGEXPS.videos.test(d[g].src) || (h += 1);
                var _ = this._getLinkDensity(i[a]), m = this._getInnerText(i[a]).length, u = !1;
                (u = s < o && !this._hasAncestorTag(i[a], "figure") || !n && s < l || c > Math.floor(s / 3) || !n && m < 25 && (0 === o || 2 < o) || !n && r < 25 && .2 < _ || 25 <= r && .5 < _ || 1 === h && m < 75 || 1 < h ? !0 : u) && i[a].parentNode.removeChild(i[a])
            }
        }
    },
    _cleanHeaders: function (e) {
        for (var t = 1; t < 3; t += 1) for (var i = e.getElementsByTagName("h" + t), n = i.length - 1; 0 <= n; --n) this._getClassWeight(i[n]) < 0 && i[n].parentNode.removeChild(i[n])
    },
    _flagIsActive: function (e) {
        return 0 < (this._flags & e)
    },
    _addFlag: function (e) {
        this._flags = this._flags | e
    },
    _removeFlag: function (e) {
        this._flags = this._flags & ~e
    },
    isProbablyReaderable: function (i) {
        var e = this._getAllNodesWithTag(this._doc, ["p", "pre"]), n = 0;
        return this._someNode(e, function (e) {
            if (i && !i(e)) return !1;
            var t = e.className + " " + e.id;
            if (this.REGEXPS.unlikelyCandidates.test(t) && !this.REGEXPS.okMaybeItsACandidate.test(t)) return !1;
            if (e.matches && e.matches("li p")) return !1;
            t = e.textContent.trim().length;
            return !(t < 140) && 20 < (n += Math.sqrt(t - 140))
        })
    },
    parse: function () {
        if (0 < this._maxElemsToParse) {
            var e = this._doc.getElementsByTagName("*").length;
            if (e > this._maxElemsToParse) throw new Error("Aborting parsing document; " + e + " elements found")
        }
        void 0 === this._doc.documentElement.firstElementChild && (this._getNextNode = this._getNextNodeNoElementProperties), this._removeScripts(this._doc), this._prepDocument();
        var e = this._getArticleMetadata(), t = e.title || this._getArticleTitle(), i = this._grabArticle();
        if (!i) return null;
        this.log("Grabbed: " + i.innerHTML), this._postProcessContent(i), e.excerpt || 0 < (n = i.getElementsByTagName("p")).length && (e.excerpt = n[0].textContent.trim());
        var n = i.textContent;
        return {
            uri: this._uri,
            title: t,
            byline: e.byline || this._articleByline,
            dir: this._articleDir,
            content: i.innerHTML,
            textContent: n,
            length: n.length,
            excerpt: e.excerpt
        }
    }
};